/**
 * @author Leinarion for www.phileasson-projekt.de
 * @file DSAKalteMain.java
 * 
 */




import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.LineNumberReader;
import java.util.Random;
import java.util.Scanner;


public class DSAKalteMain {

	/**
	 * @param args
	 */
	private static Random generator;
	private static GUI gui;
	public static  int NOOFFIGHTERS = 5;
	
	DSAKalteMain(){
		gui = new GUI();
		generator = new Random();
		gui.setMainProg(this);

	}
	/***
	 * Main method to run the program
	 * @param args
	 */
	public static void main(String[] args){
		DSAKalteMain main = new DSAKalteMain();
		main.gui.setVisible(true);
		main.gui.setMainProg(main);
		readFromFile();
	}
	/***
	 * calculates the kTP(A) the players get
	 * 
	 * @param rs: int[]		containing the kRS of each Player. Depending on rs.length the GUI calculates the number of rows needed 
	 * @param noTimes: int  containing the number of rolls with the given dice and modifications (e.g. '2' *(2W6+1) )
	 * @param noDice : int	Number of dice to roll every time. (e.g. 2* '2' W6+1
	 * @param noFaces : int what kind of dice ar used (e.g. 2*2 'W6' +1)
	 * @param mod: int		additional modification. Can also be negativ. (e.g. 2*2W6+ '1')
	 * @return int[] containing the kTP(A) for each Player. The damage for one player is at the same index as the kRS was in the rs array.
	 */
	public int[] calculate(int[] rs, int noTimes, int noDice, int noFaces, int mod){
		int[] sum = new int[rs.length];
		int damage = 0;
		for(int j=0; j<rs.length; j++){
			for(int i=0; i<noTimes ; i++){
				damage = 0;
				for(int h=0; h<noDice; h++){
				 damage += generator.nextInt(noFaces)+1;
				}
				damage = damage-rs[j]+mod;
				if( damage >= 0 )
					sum[j] = sum[j] +damage;
				if(rs[j] == -1)
					sum[j] = -1;
			}
		}
		return sum;
	}
	/**
	 * reads the values from the file importPlayers.txt, which are separated with ';' and 'new line'. Ignores Whitespace.
	 * (e.g. 
	 * Fighter0; 2
	 * Fighter1;3
	 * Fighter2;  5
	 * 
	 */
	private static void readFromFile(){
		String directory = System.getProperty("user.dir");
		File inputFile = new File(directory+"\\importPlayers.txt");
		String line = null;
		String[][] data = new String[NOOFFIGHTERS][3];
		Scanner scanner;
		int i = 0;
		try {
			BufferedReader reader = new BufferedReader(new FileReader(inputFile));
			LineNumberReader lineNumberReader = new LineNumberReader (new FileReader(inputFile));
			lineNumberReader.skip(Long.MAX_VALUE);
			NOOFFIGHTERS = lineNumberReader.getLineNumber()+1;
			data = new String[NOOFFIGHTERS][3];
			while((line = reader.readLine()) != null){
				scanner = new Scanner(line);
				scanner.useDelimiter(";");
				data[i][0] = scanner.next().replaceAll("\\s+", "");
				data[i][1] = scanner.next().replaceAll("\\s+", "");
				data[i][2] = "";
				
				i++;
			}
			reader.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}catch(IOException e){
			e.printStackTrace();
		}
		gui.setDataVector(data);
	}
}
